#ifndef VorLogin_H
#define VorLogin_H

#include <Klient.h>
#include "Login\Login.h"
#include "Account verwalten\EMail.h"
#include "Account verwalten\Geheimnis.h"
#include "Account verwalten\Name.h"
#include "Account verwalten\Passwort.h"
#include "Account verwalten\Registrierung.h"
#include "Account verwalten\Unregistrierung.h"

class VorLogin
{
private:
	Knopf				*beenden;
	Login				*login;
	EMailndern			*eMailndern;
	EMailVergessen		*eMailVergessen;
	Geheimnisndern		*geheimnisndern;
	GeheimnisVergessen	*geheimnisVergessen;
	NameVergessen		*nameVergessen;
	Passwortndern		*passwortndern;
	PasswortVergessen	*passwortVergessen;
	Registrierung		*registrierung;
	Unregistrierung		*unregistrierung;
	Schrift				*schrift;
	Bildschirm			*bildschirm;
	Fenster             *fenster;
	int ref;

public:
	// Konstruktor 
	VorLogin( Schrift *zSchrift, Bildschirm *zBildschirm );
	// Destruktor 
	~VorLogin();
	// nicht constant
	void setSichtbar( bool s ); // Setzt die Sichtbarkeit der VorLogin Oberfrche
	void setLogin( bool knopfPress ); // macht Login Oberflche sichtbar
	void setEMailndern(); // macht EMailndern Oberflche sichtbar
	void setEMailVergessen(); // macht EMailVergessen Oberflche sichtbar
	void setGeheimnisndern(); // macht Geheimnisndern Oberflche sichtbar
	void setGeheilnisVergessen(); // macht GeheimnisVergessen Oberflche sichtbar
	void setNameVergessen(); // macht NameVergessen Oberflche sichtbar
	void setPasswortndern(); // macht Passwortndern Oberflche sichtbar
	void setPasswortVergessen(); // macht passwortVergessen Oberflche sichtbar
	void setRegistrierung(); // macht Registrierung Oberflche sichtbar
	void setUnregistrierung(); // macht Unregistrierung Oberflche sichtbar
	// constant
	Login *getLogin() const; // gibt die Login Oberflche zurck
	Login *zLogin() const;
	EMailndern *getEMailndern() const; // gibt die EMailndern Oberflche zurck
	EMailndern *zEMailndern() const;
	EMailVergessen *getEMailVergessen() const; // gibt die EMailVergessen Oberflche zurck
	EMailVergessen *zEMailVergessen() const;
	Geheimnisndern *getGeheimnisndern() const; // gibt die Geheimnisndern Oberflche zurck
	Geheimnisndern *zGeheimnisndern() const;
	GeheimnisVergessen *getGeheimnisVergessen() const; // gibt die GeheimnisVergessen Oberflche zurck
	GeheimnisVergessen *zGeheimnisVergessen() const;
	NameVergessen *getNameVergessen() const; // gibt die NameVergessen Oberflche zurck
	NameVergessen *zNameVergessen() const;
	Passwortndern *getPasswortndern() const; // gibt die Passwortndern Oberflche zurck
	Passwortndern *zPasswortndern() const;
	PasswortVergessen *getPasswortVergessen() const; // gibt die PasswortVergessen Oberflche zurck
	PasswortVergessen *zPasswortVergessen() const;
	Registrierung *getRegistrierung() const; // gibt die Registrierung Oberflche zurck
	Registrierung *zRegistrierung() const;
	Unregistrierung *getUnregistrierung() const; // gibt die Unregistrierung Oberflche zurck
	Unregistrierung *zUnregistrierung() const;
	Fenster *zFenster() const;
	// Reference Counting
	VorLogin *getThis();
	VorLogin *release();
};

// Ereignisse
bool VorLoginBeendenME( void *p, void *obj, MausEreignis me );

#endif